$Title Import and reformating program for the 1998 South African SAM
$ONEMPTY

SET AC /
         i_agri
         i_coal
         i_gold
         i_othmn
         i_food
         i_bevtab
         i_text
         i_appar
         i_leath
         i_footw
         i_wood
         i_paper
         i_print
         i_petro
         i_chem
         i_othch
         i_rubb
         i_plast
         i_glass
         i_nomet
         i_iron
         i_nofer
         i_metpr
         i_machn
         i_elmac
         i_comeq
         i_scieq
         i_vehic
         i_trneq
         i_furn
         i_othin
         i_elegs
         i_water
         i_const
         i_trade
         i_hotel
         i_trans
         i_comm
         i_finan
         i_bus
         i_mothr
         i_othpr
         i_gvtsrv
         c_agri
         c_coal
         c_gold
         c_othmn
         c_food
         c_bevtab
         c_text
         c_appar
         c_leath
         c_footw
         c_wood
         c_paper
         c_print
         c_petro
         c_chem
         c_othch
         c_rubb
         c_plast
         c_glass
         c_nomet
         c_iron
         c_nofer
         c_metpr
         c_machn
         c_elmac
         c_comeq
         c_scieq
         c_vehic
         c_trneq
         c_furn
         c_othin
         c_elegs
         c_water
         c_const
         c_trade
         c_hotel
         c_trans
         c_comm
         c_finan
         c_bus
         c_mothr
         c_othpr
         c_gvtsrv
         trm
         tre
         trd
         cap
         lablo
         labmed
         labhi
         firms
         hhd0
         hhd1
         hhd2
         hhd3
         hhd4
         hhd5
         hhd6
         hhd7
         hhd8
         hhd91
         hhd921
         hhd922
         hhd923
         hhd924
         instax
         factax
         imptax
         exptax
         vatax
         acttax
         comtax
         gov
         row
         s-i
         dstk
         total
         dum
         TRNCSTDOM
         TRNCSTEXP
         TRNCSTIMP
         /;

SET A(AC)  activities /
         i_agri
         i_coal
         i_gold
         i_othmn
         i_food
         i_bevtab
         i_text
         i_appar
         i_leath
         i_footw
         i_wood
         i_paper
         i_print
         i_petro
         i_chem
         i_othch
         i_rubb
         i_plast
         i_glass
         i_nomet
         i_iron
         i_nofer
         i_metpr
         i_machn
         i_elmac
         i_comeq
         i_scieq
         i_vehic
         i_trneq
         i_furn
         i_othin
         i_elegs
         i_water
         i_const
         i_trade
         i_hotel
         i_trans
         i_comm
         i_finan
         i_bus
         i_mothr
         i_othpr
         i_gvtsrv
/;

SET AAGR(A)  agricultural activities /
         i_agri
/;

ACES(A) = no;
ALEO(A)$(NOT ACES(A)) = yes;
ANAGR(A) = NOT AAGR(A);

SET C(AC)  commodities /
         c_agri
         c_coal
         c_gold
         c_othmn
         c_food
         c_bevtab
         c_text
         c_appar
         c_leath
         c_footw
         c_wood
         c_paper
         c_print
         c_petro
         c_chem
         c_othch
         c_rubb
         c_plast
         c_glass
         c_nomet
         c_iron
         c_nofer
         c_metpr
         c_machn
         c_elmac
         c_comeq
         c_scieq
         c_vehic
         c_trneq
         c_furn
         c_othin
         c_elegs
         c_water
         c_const
         c_trade
         c_hotel
         c_trans
         c_comm
         c_finan
         c_bus
         c_mothr
         c_othpr
         c_gvtsrv
/;


*Note: if your SAM does not include elements for this set, leave it empty.
SET CAGR(C)    agricultural commodities  /
         c_agri
/;

CNAGR(C)      = NOT CAGR(C);

SETS
 CTD(AC)      domestic transactions cost account / TRD /
 CTE(AC)      export transactions cost account   / TRE /
 CTM(AC)      import transactions cost account   / TRM /;


SET F(AC)  factors /
         labhi
         labmed
         lablo
         cap
/;

SET FLAB(F) labor /
         lablo
         labmed
         labhi
/;


SET FLND(F)   land / /;

SET FCAP(F) capital /
         cap
/;

SET INS(AC)  institutions /
*Households
         hhd0
         hhd1
         hhd2
         hhd3
         hhd4
         hhd5
         hhd6
         hhd7
         hhd8
         hhd91
         hhd921
         hhd922
         hhd923
         hhd924
*Enterprises
         firms
*Government and Rest of World
         gov
         row
/;

SET INSD(INS)  domestic institutions /
*Households
         hhd0
         hhd1
         hhd2
         hhd3
         hhd4
         hhd5
         hhd6
         hhd7
         hhd8
         hhd91
         hhd921
         hhd922
         hhd923
         hhd924
*Enterprises
         firms
*Government
         gov
/;

SET INSDNG(INSD) domestic non-government institutions /
*Households
         hhd0
         hhd1
         hhd2
         hhd3
         hhd4
         hhd5
         hhd6
         hhd7
         hhd8
         hhd91
         hhd921
         hhd922
         hhd923
         hhd924
*Enterprises
         firms
/;

*Note: if your SAM does not include elements for this set, leave it empty.
SET EN(INSDNG)  enterprises /
         firms
/;

SET H(INSDNG)  households /
         hhd0
         hhd1
         hhd2
         hhd3
         hhd4
         hhd5
         hhd6
         hhd7
         hhd8
         hhd91
         hhd921
         hhd922
         hhd923
         hhd924
/;

SET HPR(H)  households /
         hhd0
         hhd1
         hhd2
         hhd3
/;


ACNT(AC) = YES; ACNT('TOTAL') = NO;

DISPLAY ACES, ALEO, AAGR, ANAGR, CAGR, CNAGR;

* SAM ------------------------------------------------------------------------------------------------------------------

ALIAS (AC,ACP);
PARAMETER SAM(AC,ACP);
$LIBINCLUDE XLIMPORT SAM c:\data\tips\sacge98\sacge98\SA98fullmod_July02\SA98fullmodSAM.xls XLRANGE

DISPLAY SAM;

*** Must decide if scaling is going to be necessary
SAM(AC,ACP) = SAM(AC,ACP) / 1000 ;

*If account balances exceed a critical maximum value, SAMBAL.INC will balance the SAM exactly.
$INCLUDE c:\data\tips\sacge98\sacge98\SA98fullmod_July02\SAMBAL.INC

*Account totals are recomputed. Check for SAM balance.
SAM('TOTAL',AC) = 0;
SAM(AC,'TOTAL') = 0;
SAM('TOTAL',AC) = SUM(ACNT, SAM(ACNT,AC));
SAM(AC,'TOTAL') = SUM(ACNT, SAM(AC,ACNT));

PARAMETER BALCHK(AC) column minus row total for SAM after running SAMBAL;
BALCHK(AC) = SAM('TOTAL',AC) - SAM(AC,'TOTAL');
DISPLAY "After running SAMBAL", BALCHK;
*DISPLAY "After running SAMBAL", SAM;

CINV(C)$SAM(C,'S-I') = YES;

DISPLAY CINV;

*3. ELASTICITIES ####################################################

*Trade elasticities========================================

*SIGMAQ is the elasticity of substitution between imports and domestic output in domestic demand.
*SIGMAT is the elasticity of transformation for domestic marketed output between exports and domestic supplies.

SET TRDELAS  trade elasticities /
 SIGMAQ  Armington elasticity
 SIGMAT  CET elasticity
/;

PARAMETER TRADELAS(AC,TRDELAS)   Armington and CET elasticities by commodity;

$LIBINCLUDE XLIMPORT TRADELAS c:\data\tips\sacge98\sacge98\SA98fullmod_July02\SA98fullmodSAM.xls TRDELAS

*Production elasticities===================================
PARAMETER ELASPAR(A,*);
PARAMETER        PRODELAS(A)  Elas of substit bt. factors - bottom of technology nest
                 PRODELAS2(A)  Elas of substit bt. agg fac & intermed - top of tech nest
;

$LIBINCLUDE XLIMPORT ELASPAR c:\data\tips\sacge98\sacge98\SA98fullmod_July02\SA98fullmodSAM.xls PRODELAS

PRODELAS(A) = ELASPAR(A,'PRODELAS');
PRODELAS2(A) = ELASPAR(A,'PRODELAS2');

PARAMETER ELASAC(C) output aggregation elasticity for commodity C;
ELASAC(C)    = 4;

*Household population data=================================

*Note: population data are not needed to run the model. However, they may be useful for verification of household
*model parameters and for report parameters.

PARAMETER POP(H) Base-year population for household h (units) / /;

*Household consumption elasticities ------------------------------------------------------------------------------------

PARAMETER LESELAS1(C,H) Exp'e elasticity of market dem for com c by hhd h;

$LIBINCLUDE xlimport LESELAS1 c:\data\tips\sacge98\sacge98\SA98fullmod_July02\SA98fullmodSAM.xls LES1


PARAMETERS
         FRISCH(H)        Frisch parameter for household LES demand
         LESELAS2(A,C,H)  Exp'e elasticity of home dem by com - act - hhd
;

FRISCH(H)           = -3;

LESELAS2(A,C,H)     = 0;

*4. PHYSICAL FACTOR QUANTITIES ######################################

PARAMETER QFSBASE(F)   base-year qnty of supply for factor f /

/;

*         labhi      1206219
*         labmed     2831445
*         lablo      2791055
*         cap        1270921

PARAMETER QFBASE(F,A);

*QFBASE(F,A) = 0;

$libinclude xlimport QFBASE c:\data\tips\sacge98\sacge98\SA98fullmod_July02\SA98fullmodSAM.xls FACDEM

*TABLE QFBASE(F,A)  qnty of factor f employed by activity a;

*Scale QFBASE to match SAM so that wages are nicely scaled.
QFBASE(F,A)   = QFBASE(F,A)/1000 ;

*5. COMMODITY VALUE SHARES FOR HOME CONSUMPTION #####################

PARAMETER shrhome(A,C,H) value share for comm'y c in home cons of hhd h from act a;

shrhome(A,C,H) = 0;

*6. INITIALIZATION OF TAX DATA ######################################

SET
 TX  taxes in the model /
 INSTAX         direct taxes on domestic institutions
 FACTAX         direct factor taxes
 IMPTAX         import taxes
 EXPTAX         export taxes
 VATAX          value-added taxes
 ACTTAX         taxes on activity revenue
 COMTAX         taxes on commodity sales in domestic market
 /
;

PARAMETER
 TAXPAR(TX,AC)   payment by account ac to tax account tx
 ;

ALIAS(TX,TXP);


*!!: Starting from here, the user should supply names of matching tax
*accounts in the SAM on the right-hand side.

*direct taxes on domestic institutions
TAXPAR('INSTAX',INSD)  = SAM('INSTAX',INSD);

*direct factor taxes
TAXPAR('FACTAX',F)     = 0;

*import taxes
TAXPAR('IMPTAX',C)   = SAM('IMPTAX',C);

*export taxes
 TAXPAR('EXPTAX',C)     = 0;

*value-added taxes
 TAXPAR('VATAX',A)     = 0 ;

*taxes on activity revenue
 TAXPAR('ACTTAX',A)     = SAM('ACTTAX',A);

*taxes on commodity sales in domestic market
 TAXPAR('COMTAX',C)     = SAM('COMTAX',C);